## freecad 0.18+dfsg1

=== debian/changelog ===
freecad (0.18+dfsg1-1) unstable; urgency=medium

  * [64167ef] New upstream version 0.18+dfsg1
  * [8c882c8] Remove upstreamed patches fix-start-workbench and
    fix_qt-5.11_build
  * [7d77b28] Add NEWS file to announce Python 3 switch

 -- Kurt Kremitzki <kurt@kwk.systems>  Thu, 14 Mar 2019 21:43:55 -0500

=== debian/control ===
Source: freecad
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sebastian Kuzminsky <seb@highlab.com>,
           Kurt Kremitzki <kurt@kwk.systems>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 11~),
               dh-exec,
               dh-python,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-graph-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-signals-dev,
               libboost-thread-dev,
               libcoin-dev,
               libopencv-dev | libcv-dev,
               libeigen3-dev (>= 3.3~beta1),
               libgts-bin,
               libgts-dev,
               libkdtree++-dev,
               libmedc-dev,
               libocct-data-exchange-dev,
               libocct-ocaf-dev,
               libocct-visualization-dev,
               libproj-dev,
               libpyside2-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libshiboken2-dev,
               libspnav-dev,
               libvtk7-dev,
               libx11-dev,
               libxerces-c-dev,
               libzipios++-dev,
               lsb-release,
               occt-draw,
               pyside2-tools,
               python-pyside2.qtcore,
               python-pyside2.qtgui,
               python-pyside2.qtsvg,
               python-pyside2.qtwidgets,
               python-dev,
               python-ply,
               python3-pyside2.qtcore,
               python3-pyside2.qtgui,
               python3-pyside2.qtsvg,
               python3-pyside2.qtwidgets,
               python3-dev,
               python3-ply,
               qtbase5-dev,
               qttools5-dev,
               swig,
Build-Depends-Indep: doxygen
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/freecad
Vcs-Git: https://salsa.debian.org/science-team/freecad.git
Homepage: http://freecadweb.org/

Package: freecad
Architecture: all
Depends: freecad-python3 | freecad-python2,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: calculix-ccx,
            graphviz
Suggests: freecad-doc,
          povray,
          python-collada,
Breaks: freecad (<< 0.18~)
Replaces: freecad (<< 0.18~)
Description: Extensible Open Source CAx program
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This is a metapackage of FreeCAD component packages.

Package: freecad-python2
Architecture: any
Depends: freecad-common,
         freecad-runtime,
         python-matplotlib,
         python-pivy,
         python-pyside2.qtcore,
         python-pyside2.qtgui,
         python-pyside2.qtsvg,
         python-pyside2.qtwidgets,
         python-pyside2uic,
         libfreecad-python2-0.18 (<< ${binary:Version}+1~),
         libfreecad-python2-0.18 (>= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Breaks: libfreecad-python2-0.17
Conflicts: libfreecad-python2-0.17
Replaces: libfreecad-python2-0.17
Description: Extensible Open Source CAx program - Python 2 binaries
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains the FreeCAD binaries built against Python 2.

Package: freecad-python3
Architecture: any
Depends: freecad-common,
         freecad-runtime,
         python3-matplotlib,
         python3-pivy,
         python3-pyside2.qtcore,
         python3-pyside2.qtgui,
         python3-pyside2.qtsvg,
         python3-pyside2.qtwidgets,
         python3-pyside2uic,
         libfreecad-python3-0.18 (<< ${binary:Version}+1~),
         libfreecad-python3-0.18 (>= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Breaks: libfreecad-python2-0.17
Conflicts: libfreecad-python2-0.17
Replaces: libfreecad-python2-0.17
Description: Extensible Open Source CAx program - Python 3 binaries
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains the FreeCAD binaries built against Python 3.

Package: freecad-runtime
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Extensible Open Source CAx program - runtime files
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains Python 2/3 runtime files.

Package: freecad-common
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: freecad (<< 0.18~), freecad-python2 (<< 0.18~)
Conflicts: freecad (<< 0.18~), freecad-python2 (<< 0.18~)
Replaces: freecad (<< 0.18~), freecad-python2 (<< 0.18~)
Description: Extensible Open Source CAx program - common files
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains FreeCAD common files and resources.

Package: libfreecad-python2-0.18
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Extensible Open Source CAx program - Python 2 library files
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains shared library files for FreeCAD built against Python 2.

Package: libfreecad-python3-0.18
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Extensible Open Source CAx program - Python 3 library files
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains shared library files for FreeCAD built against Python 3.

## freecad 0.18.1+dfsg1+git201904282144

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)
project(FreeCAD_trunk)

set(PACKAGE_NAME "FreeCAD")
set(PACKAGE_VERSION_NAME "Vulcan")
set(PACKAGE_VERSION_MAJOR "0")
set(PACKAGE_VERSION_MINOR "18.1")
set(PACKAGE_VERSION_PATCH "13500")

set(FREECAD_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}")
set(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}")
set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")

if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
    if(POLICY CMP0020)
        cmake_policy(SET CMP0020 NEW)
    endif(POLICY CMP0020)
    # added in cmake 3.0
    if(POLICY CMP0050)
        cmake_policy(SET CMP0050 NEW)
    endif(POLICY CMP0050)
    if (POLICY CMP0045)
        cmake_policy(SET CMP0045 NEW)
    endif(POLICY CMP0045)
    if (POLICY CMP0072)
        cmake_policy(SET CMP0072 OLD)
    endif(POLICY CMP0072)
endif(COMMAND cmake_policy)

find_program(CCACHE_PROGRAM ccache)  #This check should occur before project()
if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

# include local  modules
include(AddFileDependencies)
include(cMake/FreeCadMacros.cmake)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")


#if(CMAKE_CFG_INTDIR STREQUAL .)
    # No Debug/Release output paths
    set(DEBUG_MAIN_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
    set(RELEASE_MAIN_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
#else(CMAKE_CFG_INTDIR STREQUAL .)
#   set(DEBUG_MAIN_OUTPUT_PATH ${CMAKE_BINARY_DIR}/src/Main/Debug)
#   set(RELEASE_MAIN_OUTPUT_PATH ${CMAKE_BINARY_DIR}/src/Main/Release)
#endif(CMAKE_CFG_INTDIR STREQUAL .)

if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    set(CMAKE_COMPILER_IS_CLANGXX TRUE)
endif (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")

# ================================================================================

# Allow developers to use Boost < 1.48
if(NOT ${BOOST_MIN_VERSION})
   set(BOOST_MIN_VERSION 1.48)
endif()

# For older cmake versions the variable 'CMAKE_CXX_COMPILER_VERSION' is missing
IF(CMAKE_COMPILER_IS_GNUCXX AND NOT CMAKE_CXX_COMPILER_VERSION)
    EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                    OUTPUT_VARIABLE CMAKE_CXX_COMPILER_VERSION)
ENDIF(CMAKE_COMPILER_IS_GNUCXX AND NOT CMAKE_CXX_COMPILER_VERSION)

# Enabled C++11 for Freecad 0.17 and later
IF(FREECAD_VERSION VERSION_GREATER 0.16)
    set(BUILD_ENABLE_CXX_STD "C++11"  CACHE STRING  "Enable C++ standard")
    set_property(CACHE BUILD_ENABLE_CXX_STD PROPERTY STRINGS
                 "C++11"
                 "C++14"
                 "C++17"
    )

    IF(CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.7)
        MESSAGE(FATAL_ERROR "FreeCAD 0.17 and later requires C++11.  G++ must be 4.7 or later, the used version is ${CMAKE_CXX_COMPILER_VERSION}")
    ELSEIF(CMAKE_COMPILER_IS_CLANGXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.3)
        MESSAGE(FATAL_ERROR "FreeCAD 0.17 and later requires C++11.  Clang must be 3.3 or later, the used version is ${CMAKE_CXX_COMPILER_VERSION}")
    ENDIF()
ENDIF(FREECAD_VERSION VERSION_GREATER 0.16)

# Log the compiler and version
MESSAGE(STATUS "Compiler: ${CMAKE_CXX_COMPILER_ID}, version: ${CMAKE_CXX_COMPILER_VERSION}")

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX)
    include(cMake/ConfigureChecks.cmake)
    configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
    add_definitions(-DHAVE_CONFIG_H)

    # Escape the two plus chars as otherwise cmake complains about invalid regex
    if(${BUILD_ENABLE_CXX_STD} MATCHES "C\\+\\+17")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
    elseif(${BUILD_ENABLE_CXX_STD} MATCHES "C\\+\\+14")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    elseif (${BUILD_ENABLE_CXX_STD} MATCHES "C\\+\\+11")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    endif()

    set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-write-strings ${CMAKE_CXX_FLAGS}")
    INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

    # get linker errors as soon as possible and not at runtime e.g. for modules
    if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-undefined,error")
    elseif(UNIX)
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
    endif()
endif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX)

if(CMAKE_COMPILER_IS_CLANGXX)
    # Disable warning about potentially uninstantiated static members
    # because it leads to a lot of false-positives.
    #
    # https://en.wikipedia.org/wiki/Xcode#Latest_versions
    if (APPLE)
      if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-undefined-var-template")
      endif()
    elseif (UNIX)
      if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.9)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-undefined-var-template")
      endif()
    endif()

    # older boost.preprocessor turn off variadics for clang
    add_definitions(-DBOOST_PP_VARIADICS=1)
    message(STATUS "Force BOOST_PP_VARIADICS=1 for clang")
endif()


# ================================================================================
# Output directories for install target

if(WIN32)
    SET(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "Installation root directory")
else(WIN32)
    SET(CMAKE_INSTALL_PREFIX "/usr/lib${LIB_SUFFIX}/freecad" CACHE PATH "Installation root directory")
endif(WIN32)

SET(CMAKE_INSTALL_DATADIR data CACHE PATH "Output directory for data and resource files")
SET(CMAKE_INSTALL_INCLUDEDIR include CACHE PATH "Output directory for header files")
SET(CMAKE_INSTALL_DOCDIR doc CACHE PATH "Output directory for documentation and license files")
# Don't set it without manual adoption of LibDir variable in src/App/FreeCADInit.py
SET(CMAKE_INSTALL_LIBDIR lib CACHE PATH "Output directory for libraries")

if(NOT WIN32)
    if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_LIBDIR})
	    SET(CMAKE_INSTALL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    endif(NOT IS_ABSOLUTE ${CMAKE_INSTALL_LIBDIR})
endif(NOT WIN32)

SET(PYCXX_INCLUDE_DIR
    "${CMAKE_SOURCE_DIR}/src" CACHE PATH
    "Path to the directory containing PyCXX's CXX/Config.hxx include file")
SET(PYCXX_SOURCE_DIR
    "${CMAKE_SOURCE_DIR}/src/CXX" CACHE PATH
    "Path to the directory containing PyCXX's cxxextensions.c source file")

# used as compiler defines
SET(RESOURCEDIR "${CMAKE_INSTALL_DATADIR}")
SET(DOCDIR "${CMAKE_INSTALL_DOCDIR}")

MESSAGE(STATUS "prefix: ${CMAKE_INSTALL_PREFIX}")
MESSAGE(STATUS "datadir: ${CMAKE_INSTALL_DATADIR}")
MESSAGE(STATUS "docdir: ${CMAKE_INSTALL_DOCDIR}")
MESSAGE(STATUS "includedir: ${CMAKE_INSTALL_INCLUDEDIR}")
MESSAGE(STATUS "libdir: ${CMAKE_INSTALL_LIBDIR}")
MESSAGE(STATUS "cmake: ${CMAKE_VERSION}")

# ==============================================================================
# == Win32 is default behaviour use the LibPack copied in Source tree ==========
if(MSVC)
    OPTION(FREECAD_RELEASE_PDB "Create PDB files for Release version." ON)
    OPTION(FREECAD_RELEASE_SEH "Enable Structured Exception Handling for Release version." ON)
    OPTION(FREECAD_LIBPACK_USE "Use the LibPack to Build FreeCAD (only Win32 so far)." ON)
    OPTION(FREECAD_LIBPACK_USEPYSIDE "Use PySide in LibPack rather to PyQt and Swig." ON)
    set(FREECAD_LIBPACK_DIR ${CMAKE_SOURCE_DIR} CACHE PATH  "Directory of the FreeCAD LibPack")
    OPTION(BUILD_USE_PCH "Activate precompiled headers where it's used." ON)
else(MSVC)
    OPTION(FREECAD_LIBPACK_USE "Use the LibPack to Build FreeCAD (only Win32 so far)." OFF)
    set(FREECAD_LIBPACK_DIR ""  CACHE PATH  "Directory of the FreeCAD LibPack")
endif(MSVC)

# ==============================================================================
# == All the options for the build process    ============

# Switch to build FreeCAD with Qt5
OPTION(BUILD_QT5 "Build with Qt5." OFF)
OPTION(BUILD_GUI "Build FreeCAD Gui. Otherwise you have only the command line and the Python import module." ON)
OPTION(FREECAD_USE_EXTERNAL_ZIPIOS "Use system installed zipios++ instead of the bundled." OFF)
OPTION(FREECAD_USE_EXTERNAL_SMESH "Use system installed smesh instead of the bundled." OFF)
OPTION(FREECAD_USE_EXTERNAL_KDL "Use system installed orocos-kdl instead of the bundled." OFF)
OPTION(FREECAD_USE_FREETYPE "Builds the features using FreeType libs" ON)
OPTION(FREECAD_BUILD_DEBIAN "Prepare for a build of a Debian package" OFF)
OPTION(BUILD_WITH_CONDA "Set ON if you build freecad with conda" OFF)
OPTION(OCCT_CMAKE_FALLBACK "disable usage of occt-config files" OFF)
if (WIN32 OR APPLE)
    OPTION(FREECAD_USE_QT_FILEDIALOG "Use Qt's file dialog instead of the native one." OFF)
else()
    OPTION(FREECAD_USE_QT_FILEDIALOG "Use Qt's file dialog instead of the native one." ON)
endif()

# https://blog.kitware.com/constraining-values-with-comboboxes-in-cmake-cmake-gui/
set(FREECAD_USE_OCC_VARIANT "Community Edition"  CACHE STRING  "Official OpenCASCADE version or community edition")
set_property(CACHE FREECAD_USE_OCC_VARIANT PROPERTY STRINGS
             "Official Version"
             "Community Edition"
)

if (BUILD_QT5)
  OPTION(FREECAD_USE_QTOPENGL_WIDGET "Replace QGLWidget with QOpenGLWidget." ON)
  if (FREECAD_USE_QTOPENGL_WIDGET)
    set(HAVE_QT5_OPENGL 1)
  endif()
endif()
configure_file(${CMAKE_SOURCE_DIR}/src/QtOpenGL.h.cmake ${CMAKE_BINARY_DIR}/src/QtOpenGL.h)

if(APPLE)
    OPTION(FREECAD_CREATE_MAC_APP "Create app bundle on install" OFF)

    if(FREECAD_CREATE_MAC_APP)
        install(
            DIRECTORY ${CMAKE_SOURCE_DIR}/src/MacAppBundle/FreeCAD.app/
            DESTINATION ${CMAKE_INSTALL_PREFIX}/${PACKAGE_NAME}.app
        )

        # It should be safe to assume we've got sed on OSX...
        install(CODE "
            execute_process(COMMAND
                sed -i \"\" -e s/VERSION_STRING_FROM_CMAKE/${PACKAGE_VERSION}/
                -e s/NAME_STRING_FROM_CMAKE/${PACKAGE_NAME}/
                ${CMAKE_INSTALL_PREFIX}/${PACKAGE_NAME}.app/Contents/Info.plist)
               ")

        set(CMAKE_INSTALL_PREFIX
            ${CMAKE_INSTALL_PREFIX}/${PACKAGE_NAME}.app/Contents)
        set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib)
    endif(FREECAD_CREATE_MAC_APP)
    set(CMAKE_MACOSX_RPATH TRUE)
endif(APPLE)

OPTION(BUILD_FEM "Build the FreeCAD FEM module" ON)
OPTION(BUILD_SANDBOX "Build the FreeCAD Sandbox module which is only for testing purposes" OFF)
OPTION(BUILD_TEMPLATE "Build the FreeCAD template module which is only for testing purposes" OFF)
OPTION(BUILD_ADDONMGR "Build the FreeCAD addon manager module" ON)
OPTION(BUILD_ARCH "Build the FreeCAD Architecture module" ON)
OPTION(BUILD_ASSEMBLY "Build the FreeCAD Assembly module" OFF)
OPTION(BUILD_COMPLETE "Build the FreeCAD complete module" ON)
OPTION(BUILD_DRAFT "Build the FreeCAD draft module" ON)
OPTION(BUILD_DRAWING "Build the FreeCAD drawing module" ON)
OPTION(BUILD_IDF "Build the FreeCAD idf module" ON)
OPTION(BUILD_IMAGE "Build the FreeCAD image module" ON)
OPTION(BUILD_IMPORT "Build the FreeCAD import module" ON)
OPTION(BUILD_INSPECTION "Build the FreeCAD inspection module" ON)
OPTION(BUILD_JTREADER "Build the FreeCAD jt reader module" OFF)
OPTION(BUILD_MATERIAL "Build the FreeCAD material module" ON)
OPTION(BUILD_MESH "Build the FreeCAD mesh module" ON)
OPTION(BUILD_MESH_PART "Build the FreeCAD mesh part module" ON)
OPTION(BUILD_FLAT_MESH "Build the FreeCAD flat mesh module" OFF)
OPTION(BUILD_OPENSCAD "Build the FreeCAD openscad module" ON)
OPTION(BUILD_PART "Build the FreeCAD part module" ON)
OPTION(BUILD_PART_DESIGN "Build the FreeCAD part design module" ON)
OPTION(BUILD_PATH "Build the FreeCAD path module" ON)
OPTION(BUILD_PLOT "Build the FreeCAD plot module" ON)
OPTION(BUILD_POINTS "Build the FreeCAD points module" ON)
OPTION(BUILD_RAYTRACING "Build the FreeCAD ray tracing module" ON)

=== src/Doc/CMakeLists.txt ===

configure_file(ThirdPartyLibraries.html
    ${CMAKE_BINARY_DIR}/doc/ThirdPartyLibraries.html COPYONLY)



if(BUILD_GUI)
    #FILE(GLOB QCH_FILES freecad.qch.part*)
    #list(SORT QCH_FILES)
    #set (DEST_FILE ${CMAKE_BINARY_DIR}/doc/freecad.qch)
    #foreach(SRC_FILE ${QCH_FILES})
        #if(${SRC_FILE} IS_NEWER_THAN ${DEST_FILE})
            #EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/src/Tools/catfiles.py
                  #--outputfile=${DEST_FILE} ${QCH_FILES}
                  #WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  #OUTPUT_STRIP_TRAILING_WHITESPACE)
            #break()
        #endif()
    #endforeach()

    #configure_file(freecad.qhc ${CMAKE_BINARY_DIR}/doc/freecad.qhc COPYONLY)
    #INSTALL(FILES
        #${CMAKE_BINARY_DIR}/doc/freecad.qch
        #DESTINATION ${CMAKE_INSTALL_DOCDIR}
    #)
endif(BUILD_GUI)

INSTALL(FILES
    #freecad.qhc
    ThirdPartyLibraries.html
    DESTINATION ${CMAKE_INSTALL_DOCDIR}
)

find_package(Doxygen)
if(DOXYGEN_FOUND)

    IF (DOXYGEN_DOT_EXECUTABLE)
        SET(HAVE_DOT YES)
    ELSE (DOXYGEN_DOT_EXECUTABLE)
        message(STATUS "Note: Doxygen docs will look better with graphviz's dot installed.")
        SET(HAVE_DOT NO)
    ENDIF (DOXYGEN_DOT_EXECUTABLE)


    SET(DOXYGEN_LANGUAGE "English" CACHE STRING "Language used by doxygen")
    MARK_AS_ADVANCED(DOXYGEN_LANGUAGE)

# note: this test is obsolete if DevDoc target is used
    if (NOT BUILD_GUI)
        message("Note: Gui is not built. Documentation may lack some parts.")
    endif (NOT BUILD_GUI)

    # directory order seems important for correct macro expansion
    # (files containing macros definitions must be parsed before the files using them)
    SET(DOXYGEN_SOURCE_DIR ${COIN3D_INCLUDE_DIRS}/Inventor/fields/SoSubField.h 
                           ${CMAKE_SOURCE_DIR}/src/CXX 
                           ${CMAKE_SOURCE_DIR}/src/zipios++ 
                           ${CMAKE_SOURCE_DIR}/src/3rdParty
                           ${CMAKE_SOURCE_DIR}/src/Build 
                           ${CMAKE_SOURCE_DIR}/src/Base 
                           ${CMAKE_BINARY_DIR}/src/Base 
                           ${CMAKE_SOURCE_DIR}/src/App 
                           ${CMAKE_BINARY_DIR}/src/App 
                           ${CMAKE_SOURCE_DIR}/src/Gui 
                           ${CMAKE_BINARY_DIR}/src/Gui 
                           ${CMAKE_SOURCE_DIR}/src/Mod
                           ${CMAKE_BINARY_DIR}/src/Mod
                           ${CMAKE_SOURCE_DIR}/src/Main 
                           ${CMAKE_SOURCE_DIR}/src/Doc 
    )
    STRING(REGEX REPLACE ";" " " DOXYGEN_INPUT_LIST "${DOXYGEN_SOURCE_DIR}")

    # exclude some subdirectories
    # src/Tools : content not relevant ?
    # src/3rdParty/CxImage : Windows thumbnailer
    set(        DOXYGEN_EXCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/Tools)
    list(APPEND DOXYGEN_EXCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/3rdParty/CxImage)
    list(APPEND DOXYGEN_EXCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/3rdParty/salomesmesh)
    list(APPEND DOXYGEN_EXCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/Mod/Arch/Dice3DS)
    list(APPEND DOXYGEN_EXCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/Doc/sphinx)
    # deprecated modules
    list(APPEND DOXYGEN_EXCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/Mod/Assembly)
    list(APPEND DOXYGEN_EXCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/Mod/Cam)
    list(APPEND DOXYGEN_EXCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/Mod/Complete)

    STRING(REGEX REPLACE ";" " " DOXYGEN_EXCLUDE_LIST "${DOXYGEN_EXCLUDE_DIR}")

    SET(DOXYGEN_OUTPUT_DIR ${CMAKE_BINARY_DIR}/doc/SourceDocu)
    SET(DOXYGEN_IMAGE_PATH ${CMAKE_SOURCE_DIR}/src/Gui/Icons)
    SET(DOXYGEN_LAYOUT_FILE ${CMAKE_SOURCE_DIR}/src/Doc/FreecadDoxygenLayout.xml)

    find_package(Coin3DDoc)
    if( COIN3D_DOC_FOUND )
        SET(DOXYGEN_TAGFILES 
            ${COIN3D_DOC_TAGFILE}=${COIN3D_DOC_PATH}
        )
    endif( COIN3D_DOC_FOUND )

    # Try to get some git information about the source tree
    EXECUTE_PROCESS(COMMAND git rev-parse --abbrev-ref HEAD
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                    OUTPUT_VARIABLE GIT_DOC_REV
                    ERROR_VARIABLE GIT_REV_FAILED
                    RESULT_VARIABLE GIT_REV_RETURN_CODE)
    if( GIT_REV_RETURN_CODE EQUAL 0 )
        EXECUTE_PROCESS(COMMAND git log -n1 "--pretty=format:%h %cD '%s'"
                        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                        OUTPUT_VARIABLE GIT_DOC_LOG
                        ERROR_VARIABLE GIT_REV_FAILED
                        RESULT_VARIABLE GIT_REV_RETURN_CODE)
        set(GIT_REVISION_INFO
            "Built from git branch ${GIT_DOC_REV}, commit ${GIT_DOC_LOG}")
    endif()

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/mainpage.dox.in
                   ${CMAKE_CURRENT_BINARY_DIR}/mainpage.dox @ONLY)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/BuildDevDoc.cfg.in  
                   ${CMAKE_CURRENT_BINARY_DIR}/BuildDevDoc.cfg @ONLY)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/BuildWebDoc.cfg.in  
                   ${CMAKE_CURRENT_BINARY_DIR}/BuildWebDoc.cfg @ONLY)
 
    # reconfigure to have all sources files generated from xml, whatever build options were
    # generate source documentation
    # delete CMakeCache to reset to default build options next time 
    ADD_CUSTOM_TARGET(DevDoc
        ${CMAKE_COMMAND} -D BUILD_GUI:BOOL=ON -D BUILD_FEM:BOOL=ON ${CMAKE_SOURCE_DIR}
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/BuildDevDoc.cfg
        COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_BINARY_DIR}/CMakeCache.txt
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
    # lightweight version for the web
    ADD_CUSTOM_TARGET(WebDoc
        ${CMAKE_COMMAND} -D BUILD_GUI:BOOL=ON -D BUILD_FEM:BOOL=ON ${CMAKE_SOURCE_DIR}
        COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/src/Doc/templates ${CMAKE_CURRENT_BINARY_DIR}/templates
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/BuildWebDoc.cfg
        COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_BINARY_DIR}/CMakeCache.txt
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

else( DOXYGEN_FOUND )
    ADD_CUSTOM_TARGET(DevDoc
                      echo "Doxygen not found.  Install it and rerun CMake")
endif( DOXYGEN_FOUND )

=== src/Mod/OpenSCAD/CMakeLists.txt ===
IF (BUILD_GUI)
    PYSIDE_WRAP_RC(OpenSCAD_QRC_SRCS Resources/OpenSCAD.qrc)
ENDIF (BUILD_GUI)

SET(OpenSCAD_SRCS
    Init.py
    InitGui.py
    OpenSCAD2Dgeom.py
    OpenSCADFeatures.py
    OpenSCADUtils.py
    OpenSCADCommands.py
    exportCSG.py
    importCSG.py
    tokrules.py
    colorcodeshapes.py
    expandplacements.py
    replaceobj.py
)
SOURCE_GROUP("" FILES ${OpenSCAD_SRCS})

SET(ply_SRCS
    ply/lex.py
    ply/README
    ply/yacc.py
    ply/__init__.py
)
SOURCE_GROUP("ply" FILES ${ply_SRCS})

set(all_files ${OpenSCAD_SRCS} )

SET(OpenSCADGuiIcon_SVG
    Resources/icons/OpenSCADWorkbench.svg
)

ADD_CUSTOM_TARGET(OpenSCAD ALL
    SOURCES ${all_files} ${OpenSCAD_QRC_SRCS} ${OpenSCADGuiIcon_SVG}
)

fc_copy_sources(OpenSCAD "${CMAKE_BINARY_DIR}/Mod/OpenSCAD" ${all_files})

fc_copy_sources(OpenSCAD "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/OpenSCAD" ${OpenSCADGuiIcon_SVG})

IF (BUILD_GUI)
    fc_target_copy_resource(OpenSCAD
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_BINARY_DIR}/Mod/OpenSCAD
        OpenSCAD_rc.py)
ENDIF (BUILD_GUI)

INSTALL(
    FILES
        ${OpenSCAD_SRCS}
        ${OpenSCAD_QRC_SRCS}
    DESTINATION
        Mod/OpenSCAD
)
INSTALL(
    FILES
        ${OpenSCADGuiIcon_SVG}
    DESTINATION
       "${CMAKE_INSTALL_DATADIR}/Mod/OpenSCAD/Resources/icons"
)

=== debian/changelog ===
freecad (0.18.1+dfsg1+git201904282144-0.1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * debian/rules: allow parallel builds
  * Drop epoch to sync with Debian versions.
  * Disable automatic dbgsym packages.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 30 Apr 2019 14:24:33 -0700

freecad (2:0.18.1+dfsg1~201904282144~ubuntu16.04.1) xenial; urgency=low

  * Auto build.

 -- Kurt Kremitzki <kkremitzki@gmail.com>  Sun, 28 Apr 2019 21:44:26 +0000

freecad (0.18.1+dfsg1-2) unstable; urgency=medium

  * [5cd3fce] Add missing pyside2 deps
  * [fd92cc2] Fix breaks+replaces relations (Closes: #926251)
  * [c61fe87] Add upstream bugfixing patch
  * [f95e30a] Fix FEM autopkgtest (Closes: #926304 #920535)

 -- Kurt Kremitzki <kurt@kwk.systems>  Sat, 27 Apr 2019 19:06:02 -0500

freecad (0.18.1+dfsg1-1) unstable; urgency=medium

  * [cab285b] Correct suggested packages
  * [576bf03] New upstream version 0.18.1+dfsg1
  * [7cec221] Update rules for 0.18.1
  * [39bac84] Add patch to display 0.18.1 version

 -- Kurt Kremitzki <kurt@kwk.systems>  Sat, 06 Apr 2019 13:52:45 -0500

## freecad 0.18.3+dfsg1

=== debian/changelog ===
freecad (0.18.3+dfsg1-0.1~mx19+1) mx; urgency=medium

  * Import new upstream version 0.18.3+dfsg1.
  * Disable automatic dbgsym packages.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 18 Jul 2019 13:09:04 -0700

freecad (0.18.2+dfsg1-1) unstable; urgency=medium

  * [bc5f8c2] New upstream version 0.18.2+dfsg1
  * [f6afef9] Remove upstream-bugfixes.patch (obsoleted by 0.18.2)
  * [bb1b36e] Don't save in non-user-writable location by default
  * [ce51375] Fix missing document icons

 -- Kurt Kremitzki <kurt@kwk.systems>  Fri, 07 Jun 2019 22:31:06 -0500

=== debian/control ===
--- 
+++ 
@@ -47,13 +47,17 @@
                python-pyside2.qtcore,
                python-pyside2.qtgui,
                python-pyside2.qtsvg,
+               python-pyside2.qtuitools,
                python-pyside2.qtwidgets,
+               python-pyside2.qtxml,
                python-dev,
                python-ply,
                python3-pyside2.qtcore,
                python3-pyside2.qtgui,
                python3-pyside2.qtsvg,
+               python3-pyside2.qtuitools,
                python3-pyside2.qtwidgets,
+               python3-pyside2.qtxml,
                python3-dev,
                python3-ply,
                qtbase5-dev,
@@ -72,11 +76,9 @@
          ${shlibs:Depends}
 Recommends: calculix-ccx,
             graphviz
-Suggests: freecad-doc,
-          povray,
-          python-collada,
-Breaks: freecad (<< 0.18~)
-Replaces: freecad (<< 0.18~)
+Suggests: povray
+Breaks: freecad (<< 0.18)
+Replaces: freecad (<< 0.18)
 Description: Extensible Open Source CAx program
  FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
  It features some key concepts like macro recording, workbenches, ability
@@ -98,7 +100,9 @@
          python-pyside2.qtcore,
          python-pyside2.qtgui,
          python-pyside2.qtsvg,
+         python-pyside2.qtuitools,
          python-pyside2.qtwidgets,
+         python-pyside2.qtxml,
          python-pyside2uic,
          libfreecad-python2-0.18 (<< ${binary:Version}+1~),
          libfreecad-python2-0.18 (>= ${binary:Version}),
@@ -106,8 +110,8 @@
          ${python:Depends},
          ${shlibs:Depends}
 Breaks: libfreecad-python2-0.17
-Conflicts: libfreecad-python2-0.17
 Replaces: libfreecad-python2-0.17
+Suggests: python-collada
 Description: Extensible Open Source CAx program - Python 2 binaries
  FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
  It features some key concepts like macro recording, workbenches, ability
@@ -128,8 +132,10 @@
          python3-pivy,
          python3-pyside2.qtcore,
          python3-pyside2.qtgui,
+         python3-pyside2.qtuitools,
          python3-pyside2.qtsvg,
          python3-pyside2.qtwidgets,
+         python3-pyside2.qtxml,
          python3-pyside2uic,
          libfreecad-python3-0.18 (<< ${binary:Version}+1~),
          libfreecad-python3-0.18 (>= ${binary:Version}),
@@ -137,7 +143,6 @@
          ${python3:Depends},
          ${shlibs:Depends}
 Breaks: libfreecad-python2-0.17
-Conflicts: libfreecad-python2-0.17
 Replaces: libfreecad-python2-0.17
 Description: Extensible Open Source CAx program - Python 3 binaries
  FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
@@ -171,9 +176,8 @@
 Architecture: all
 Depends: ${misc:Depends},
          ${shlibs:Depends}
-Breaks: freecad (<< 0.18~), freecad-python2 (<< 0.18~)
-Conflicts: freecad (<< 0.18~), freecad-python2 (<< 0.18~)
-Replaces: freecad (<< 0.18~), freecad-python2 (<< 0.18~)
+Breaks: freecad (<< 0.18), freecad-python2 (<< 0.18)
+Replaces: freecad (<< 0.18), freecad-python2 (<< 0.18)
 Description: Extensible Open Source CAx program - common files
  FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
  It features some key concepts like macro recording, workbenches, ability

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=cmake --with python2,python3

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,+bindnow

extra_flags += \
-DBUILD_QT5=ON \
-DFREECAD_BUILD_DEBIAN=ON \
-DCMAKE_CXX_FLAGS="-Wall -DHAVE_SWIG=1 -fpermissive $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)" \
-DCMAKE_C_FLAGS="-Wall -fpermissive $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)" \
-DCMAKE_SHARED_LINKER_FLAGS="$(shell dpkg-buildflags --get LDFLAGS)" \
-DLIB_SUFFIX="" \
-DCMAKE_BUILD_TYPE=RelWithDebInfo \
-DCMAKE_INSTALL_DATADIR="/usr/share/freecad" \
-DCMAKE_INSTALL_DOCDIR="/usr/share/doc/freecad-doc" \
-DCMAKE_INSTALL_PREFIX="/usr/share/freecad"

py2_flags = \
-DPYTHON_CONFIG_SUFFIX="-python2.7.${DEB_HOST_MULTIARCH}" \
-DCMAKE_INSTALL_LIBDIR="/usr/lib/freecad-python2/lib"

py3_flags = \
-DPYTHON_EXECUTABLE="/usr/bin/python3" \
-DCMAKE_INSTALL_LIBDIR="/usr/lib/freecad-python3/lib"

override_dh_auto_configure:
	dh_auto_configure --builddirectory=debian/build-py2 -- \
	    $(extra_flags) \
	    $(py2_flags)
	dh_auto_configure --builddirectory=debian/build-py3 -- \
	    $(extra_flags) \
	    $(py3_flags)

override_dh_auto_build:
	dh_auto_build --builddirectory=debian/build-py2
	dh_auto_build --builddirectory=debian/build-py3

override_dh_auto_test:
	dh_auto_test --builddirectory=debian/build-py2
	dh_auto_test --builddirectory=debian/build-py3

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build-py2
	mv debian/tmp/usr/share/freecad/bin/FreeCADCmd \
	    debian/tmp/usr/share/freecad/bin/FreeCADCmd-Python2
	mv debian/tmp/usr/share/freecad/bin/FreeCAD \
	    debian/tmp/usr/share/freecad/bin/FreeCAD-Python2
	dh_auto_install --builddirectory=debian/build-py3
	mv debian/tmp/usr/share/freecad/bin/FreeCADCmd \
	    debian/tmp/usr/share/freecad/bin/FreeCADCmd-Python3
	mv debian/tmp/usr/share/freecad/bin/FreeCAD \
	    debian/tmp/usr/share/freecad/bin/FreeCAD-Python3

override_dh_compress:
	dh_compress -X.qch -X.qhc

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.txt

override_dh_installexamples:

override_dh_missing-arch:
	dh_missing --list-missing

override_dh_strip:
	dh_strip --no-automatic-dbgsym
